#!/usr/bin/env python3

from audit.system.plugins.sysctl.parsing import Parsing
from audit.system.plugins.sysctl.sysctl import sysctl


class Sysctl:
    def __init__(self, args):
        self._objects = dict()
        self._reports = dict()
        self._audit = list()
        
        self._audit.append({
            'audit': 'file',
            'value': args["sysctl_file"],
        })
        self._audit.append({
            'audit': 'process',
            'value': 'sysctl -a',
        })

        self._sysctl()

        self._parsing = Parsing(self._objects, self._audit)

    def _sysctl(self):
        self._objects = sysctl()

    def runAudit(self):
        print("Running test for sysctl")
        # Read /etc/sysctl.conf
        self._parsing.runParsing()
        #self._reports.append(self._parsing.getResults())
        self._reports = self._parsing.getResults()

        # Run process sysctl

    def getReports(self) -> dict:
        return self._reports

